<template>
    <div v-if="isNotcryptoGroup" class="p-6">
      <div class="space-y-4">
        <div
          v-if="paymentDepositTextInfo?.Text.length > 0 && !$route.fullPath.includes('internetbanking')"
          class="p-4 text-sm rounded bg-background5 --text4 font-normal txt-info"
        >
          <span v-html="paymentDepositTextInfo?.Text"></span>
        </div>
        <div
          v-if="internetBankingDepositTextInfo?.Text.length > 0 && $route.fullPath.includes('internetbanking')"
          class="p-4 text-sm rounded bg-background5 --text4 font-normal txt-info"
        >
          <span v-html="internetBankingDepositTextInfo?.Text"></span>
        </div>
        <h5 class="--text4">{{ $t("bank") }}</h5>
        <ui-radio-group
          v-model="selectedBank"
          class="grid gap-3 select-bank"
          :class="{ 'grid-cols-2': isMobile, 'grid-cols-3': !isMobile }"
          group-name="select-bank"
        >
          <ui-radio-button
            v-for="bank in bankRadios.radios"
            :key="bank"
            :label="bank.value"
          >
            <ui-check-button
              variant="IMAGE_ONLY"
              :text="bank.value"
              :img="bank.imgSrc"
            />
          </ui-radio-button>
        </ui-radio-group>
      </div>
      <div class="mt-5 space-y-4">
        <h5 class="--text4">{{ $t("channel") }}</h5>
        <ui-radio-group
          v-model="selectedChannel"
          class="grid gap-3"
          :class="{ 'grid-cols-2': isMobile, 'grid-cols-3': !isMobile }"
          group-name="channels"
        >
          <ui-radio-button
            v-for="channel in channelRadios.radios"
            :key="channel.text"
            :label="channel.value"
          >
            <ui-check-button :text="channel.text" variant="TEXT_ONLY" />
          </ui-radio-button>
        </ui-radio-group>
      </div>
    </div>
    <div class="p-6 space-y-4">
      <el-form
        v-if="isNotcryptoGroup"
        ref="ruleFormRef"
        :model="formData"
        :rules="getRule"
        :label-position="'top'"
        :validate-on-rule-change="false"
      >
        <template v-if="isPaymentGewayMethodShowBankAcc">
          <el-form-item :label="$t('bank_account_name')" prop="bankAccountName">
            <el-input
              v-model="formData.bankAccountName"
              v-un-focus
              type="text"
            />
          </el-form-item>
          <el-form-item :label="$t('bank_account_number')" prop="bankAccountNumber">
            <el-input
              v-model="formData.bankAccountNumber"
              v-un-focus
              type="text"
              oninput="this.value = this.value.replace(/[^0-9]/g, '')"
            />
          </el-form-item>
        </template>
        <el-form-item prop="amount" :label="$t('amount')" class="amount-input">
          <el-select
            v-if="isNeedSelectAmount"
            id="amount"
            v-model="formData.amount"
            default-first-option
          >
            <el-option
              v-for="opt in amountOptions"
              :key="opt"
              :label="opt"
              :value="opt"
            />
          </el-select>
          <el-input
            v-else
            v-model="formData.amount"
            v-un-focus
            @input="onInputValue($event, formData, 'amount')"
            :placeholder="amountPlaceholder" id="amount"
          >
            <template v-if="isNeedToMultiplyByThousand" #append>000</template>
          </el-input>
          <span v-if="isNeedToMultiplyByThousand" class="order-1 mt-3 text-xs fc-hint">{{
            $t(
              `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
            )
          }}</span>
        </el-form-item>
      </el-form>
      <el-form
        v-else
        ref="cryptoCurrencyDepositFormRef"
        :model="cryptoCurrencyDepositFormData"
        :rules="cryptoCurrencyDepositRule"
        :label-position="'top'"
        :validate-on-rule-change="false"
      >
        <div class="pb-5 space-y-4"
          v-if="(paymentDepositTextInfo?.Text.length > 0 || (cryptocurrencyNetworks && cryptocurrencyNetworks.length > 0)) && !$route.fullPath.includes('internetbanking')">
          <div
            class="p-4 text-sm rounded bg-background5 --text4 font-normal txt-info"
          >
            <span v-html="paymentDepositTextInfo?.Text"></span>
          </div>
          <h5
            v-if="cryptocurrencyNetworks && cryptocurrencyNetworks.length > 0"
            class="--text4"
          >
            {{ $t("choose_your_cryptocurrency_network") }}
          </h5>
          <ui-radio-group
            v-model="cryptocurrencyNetwork"
            group-name="cryptocurrencyNetwork"
            class="grid gap-3"
            :class="{ 'grid-cols-2': isMobile, 'grid-cols-3': !isMobile }"
          >
            <ui-radio-button
              v-for="network in cryptocurrencyNetworks"
              :key="network"
              :label="network"
            >
              <ui-check-button :text="network" variant="TEXT_ONLY" />
            </ui-radio-button>
          </ui-radio-group>
        </div>
        <div class="pb-5 space-y-4"
          v-if="(internetBankingDepositTextInfo?.Text.length > 0 || (cryptocurrencyNetworks && cryptocurrencyNetworks.length > 0)) && $route.fullPath.includes('internetbanking')">
          <div
            class="p-4 text-sm rounded bg-background5 --text4 font-normal txt-info"
          >
            <span v-html="internetBankingDepositTextInfo?.Text"></span>
          </div>
          <h5
            v-if="cryptocurrencyNetworks && cryptocurrencyNetworks.length > 0"
            class="--text4"
          >
            {{ $t("choose_your_cryptocurrency_network") }}
          </h5>
          <ui-radio-group
            v-model="cryptocurrencyNetwork"
            group-name="cryptocurrencyNetwork"
            class="grid gap-3"
            :class="{ 'grid-cols-2': isMobile, 'grid-cols-3': !isMobile }"
          >
            <ui-radio-button
              v-for="network in cryptocurrencyNetworks"
              :key="network"
              :label="network"
            >
              <ui-check-button :text="network" variant="TEXT_ONLY" />
            </ui-radio-button>
          </ui-radio-group>
        </div>
        <el-form-item :label="$t('amount')" class="amount-input" prop="cryptoAmount">
          <el-input
            v-model="cryptoCurrencyDepositFormData.cryptoAmount"
            v-un-focus
            :placeholder="amountPlaceholder"
            @input="onInputValue($event, cryptoCurrencyDepositFormData, 'cryptoAmount')"
          >
            <template v-if="isNeedToMultiplyByThousand" #append>000</template>
          </el-input>
          <span v-if="isNeedToMultiplyByThousand" class="order-1 mt-3 text-xs fc-hint">{{
            $t(
              `deposit_amount_shown_by_the_system_${profile.Currency.toLowerCase()}`
            )
          }}</span>
        </el-form-item>
      </el-form>
      <div class="mt-10 text-center">
        <el-button
          type="primary"
          :disabled="isProccesing"
          round
          @click="
            submitPaymentDeposit(
              isNotcryptoGroup ? ruleFormRef : cryptoCurrencyDepositFormRef
            )
          "
          id="continue"
          >{{ $t("continue") }}</el-button
        >
      </div>
    </div>
  </template>
  <script lang="ts">
  import { defineComponent, PropType, toRefs, computed } from "vue";
  import { IGetPaymentGatewayBanksResponse } from "@/models/getPaymentGatewayBanksRespone";
  import { ProfileDto } from "@/models/getProfileResponse";
  import { store } from "@/store";

  export default defineComponent({
    name: "PaymentBankTransferDeposit",
    props: {
      paymentBanks: {
        type: Object as PropType<IGetPaymentGatewayBanksResponse>,
        required: true,
        default: {} as IGetPaymentGatewayBanksResponse,
      },
      profile: {
        type: Object as PropType<ProfileDto>,
        required: true,
        default: {} as ProfileDto,
      },
    },
    setup(props) {
      const { paymentBanks, profile } = toRefs(props);
      const {
        bankRadios,
        selectedBank,
        channelRadios,
        selectedChannel,
        isNotcryptoGroup,
        validateDepositMin,
        validateDepositMax,
        isNeedToMultiplyByThousand,
        ruleFormRef,
        formData,
        getRule,
        cryptoCurrencyDepositFormData,
        cryptoCurrencyDepositFormRef,
        cryptoCurrencyDepositRule,
        isProccesing,
        submitPaymentDeposit,
        amountPlaceholder,
        cryptocurrencyNetwork,
        cryptocurrencyNetworks,
        triggerImageError,
        paymentDepositTextInfo,
        isPaymentGewayMethodShowBankAcc,
        internetBankingDepositTextInfo,
        isNeedSelectAmount,
        amountOptions,
      } = usePaymentBankTransferDeposit(paymentBanks, profile);
      const { getAssetImage, onInputValue, allowCompany } = commonHelper;
      const isSBO = computed(() => store.state.selectedThemeName === "sbo");
      const isMobile = !useIsDesktop();

      return {
        bankRadios,
        selectedBank,
        channelRadios,
        selectedChannel,
        isNotcryptoGroup,
        validateDepositMin,
        validateDepositMax,
        isNeedToMultiplyByThousand,
        submitPaymentDeposit,
        ruleFormRef,
        formData,
        getRule,
        cryptoCurrencyDepositFormData,
        cryptoCurrencyDepositFormRef,
        cryptoCurrencyDepositRule,
        isProccesing,
        amountPlaceholder,
        cryptocurrencyNetwork,
        cryptocurrencyNetworks,
        getAssetImage,
        triggerImageError,
        isSBO,
        isMobile,
        paymentDepositTextInfo,
        onInputValue,
        isPaymentGewayMethodShowBankAcc,
        allowCompany,
        internetBankingDepositTextInfo,
        isNeedSelectAmount,
        amountOptions,
      };
    },
  });
  </script>
  <style scoped lang="scss">
  .bank-icon :deep(.el-radio-button__inner) {
    background: white;
  }
  :deep(.el-form-item__label) {
    color: var(--text5);
  }
  .amount-input :deep(.el-form-item__content) {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
  }
  [layout="peru"] {
    .ui-radio-group.select-bank {
      @media screen and (max-width: 640px) {
        grid-template-columns: repeat(2, minmax(0, 1fr));
        .check-btn__img {
          display: block;
        }
      }
      @media screen and (max-width: 450px) {
        grid-template-columns: repeat(1, minmax(0, 1fr));
      }
    }
    @media (max-width: 639px) {
      .txt-info {
          padding: 0;
        }
    }
    #channels.ui-radio-group {
      @media screen and (max-width: 450px) {
        grid-template-columns: repeat(1, minmax(0, 1fr));
      }
    }
  }
  .txt-info {
    word-break: break-word;
  }
  </style>
